#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
int main(){
    int N, Q, up=0, ik=0,td, i, j;
    cin>>N>>Q;
    vector <int> d(N);
    vector <int>k(N);
    for (i=0; i<Q; i++)
        cin>>d[i]>>k[i];
    vector<int> p(Q);
    for(i=0;i<Q;i++)
        cin>>p[i];
    vector <int> o(Q,0);
    for (j=0; j<Q; j++)
        td=p[j];
        while(ik<N && d[ik]<=td){
            up+=k[ik];
            ik++;
    }
    for(j=0;j<Q;j++)
        o[j]=min(up,td);
        cout<<o[j];
    return 0;
    }